Unit AEE1R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAE10_p;

procedure AEE1R(N :Integer; var A :Array of Real;
                var EV :Array of Real; var V :Array of Real;
                var RAB1 :Array of Real; var IERR :Integer);

implementation

procedure AEE1R(N :Integer; var A :Array of Real;
                var EV :Array of Real; var V :Array of Real;
                var RAB1 :Array of Real; var IERR :Integer);
var
I,J,B,C,D,E,F,G,H :Integer;
K,L,M,O,P,Q,R :Real;
const
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16;
begin
for I:=1 to N do
 begin
  for J:=1 to N do
   begin
    V[(I-1)+(J-1)*N] := 0.0;
_1:
   end;
  V[(I-1)+(I-1)*N] := 1.0;
  EV[I-1] := A[(I-1)+1*N];
  RAB1[I-1] := A[(I-1)+0*N];
_2:
 end;
IERR := 0;
if ( N = 1 ) 
 then goto _16;
for B:=2 to N do
 begin
_3:
  RAB1[B-2] := RAB1[B-1];
 end;
RAB1[N-1] := 0.0;
for E:=1 to N do
 begin
  C := 0;
_4:
  for F:=E to N do
   begin
    if ( F = N ) 
     then goto _6;
    if ( Abs(RAB1[F-1]) <= SYS051*(Abs(EV[F-1])+Abs(EV[F+0])) )
     then goto _6;
_5:
   end;
_6:
  P := EV[E-1];
  if ( F = E ) 
   then goto _11;
  if ( C = 30 ) 
   then goto _15;
  C := C+1;
  O := (EV[E+0]-P)/(2.0*RAB1[E-1]);
  if ( Abs(O) > 1.0 ) 
   then Q := Abs(O)*Sqrt(1.0+IntPower(1.0/O,2));
  if ( Abs(O) <= 1.0 ) 
   then Q := Sqrt(O*O+1.0);
  O := EV[F-1]-P+RAB1[E-1]/(O+Sign(Q,O));
  R := 1.0;
  L := 1.0;
  P := 0.0;
  H := F-E;
  for G:=1 to H do
   begin
    B := F-G;
    M := R*RAB1[B-1];
    K := L*RAB1[B-1];
    if ( Abs(M) < Abs(O) ) 
     then goto _7;
    L := O/M;
    Q := Sqrt(L*L+1.0);
    RAB1[B+0] := M*Q;
    R := 1.0/Q;
    L := L*R;
    goto _8;
_7:
    R := M/O;
    Q := Sqrt(R*R+1.0);
    RAB1[B+0] := O*Q;
    L := 1.0/Q;
    R := R*L;
_8:
    O := EV[B+0]-P;
    Q := (EV[B-1]-O)*R+2.0*L*K;
    P := R*Q;
    EV[B+0] := O+P;
    O := L*Q-K;
    for D:=1 to N do
     begin
      M := V[(D-1)+(B+0)*N];
      V[(D-1)+(B+0)*N] := R*V[(D-1)+(B-1)*N]+L*M;
      V[(D-1)+(B-1)*N] := L*V[(D-1)+(B-1)*N]-R*M;
_9:
     end;
_10:
   end;
  EV[E-1] := EV[E-1]-P;
  RAB1[E-1] := O;
  RAB1[F-1] := 0.0;
  goto _4;
_11:
 end;
for G:=2 to N do
 begin
  B := G-1;
  D := B;
  P := EV[B-1];
  for C:=G to N do
   begin
    if ( EV[C-1] >= P ) 
     then goto _12;
    D := C;
    P := EV[C-1];
_12:
   end;
  if ( D = B ) 
   then goto _14;
  EV[D-1] := EV[B-1];
  EV[B-1] := P;
  for C:=1 to N do
   begin
    P := V[(C-1)+(B-1)*N];
    V[(C-1)+(B-1)*N] := V[(C-1)+(D-1)*N];
    V[(C-1)+(D-1)*N] := P;
_13:
   end;
_14:
 end;
goto _16;
_15:
IERR := E;
_16:
if ( IERR <> 0 ) 
 then UTAE10(IERR,N,14);
end;

end.
